// Displays serial input buffer.  Used here to test fgets and fgetc.

/*
                      NOTES

  rx_ptr[0] rxhead, rxptr[1] rxtail, rx_ptr[2] tx_head, rx_ptr[3] tx_tail, 
  rx_ptr[4] rx_pin, rx_ptr[5] tx_pin, rx_ptr[6] mode, rx_ptr[7, 8] mode?
  rx_ptr[9]...rx

*/

#include "simpletools.h"                      // Include simple tools

static char s[20];
char c;

void display(fdserial stream)
{
  volatile int* buf = (int*) stream->drvarg[0];
  printf("rx_head = %d, rx_tail = %d\n", buf[0], buf[1]);
  char* cc = &buf[9];
  for(int i = 0; i < 16; i++)
  {
    if(cc[i]>40) printf("%c", cc[i]); else printf("<%d>", cc[i]);
  } 
  printf("%c", '\n');
  printf("tx_head = %d, tx_tail = %d\n", buf[2], buf[3]);
  for(int i = 16; i < 32; i++)
  {
    if(cc[i]>40) printf("%c", cc[i]); else printf("<%d>", cc[i]);
  } 
  printf("%c%c", '\n', '\n');  
}


int fdser_inbuf(fdserial stream)
{
  volatile int* buf = (int*) stream->drvarg[0];
  int rxHead = buf[0];
  int rxTail = buf[1]; 
  int bytes = rxHead - rxTail;
  if(bytes < 0) bytes += 16;
  return bytes;
}


int main()                                    // Main function
{
  fdserial xb = fdser_start(8, 9, 9600, 0);
  setvbuf(xb, NULL, _IONBF, 0);
  xb->_flag &= ~_IOCOOKED;

  pause(1100);                                // Wait 1 s for terminal software

  fputs("+++", xb);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);
  fgets(s, 4, xb);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);
  printf("%s\n", s);

  fputs("ATCH\r", xb);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);
  printf("\n%s\n", s);
  fgets(s, 1, xb);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);

  fputs("ATCH\r", xb);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);
  printf("try getc here\n");
  char c = fgetc(xb);
  printf("\nc = %c\n", c);
  printf("inbufct = %d\n", fdser_inbuf(xb));
  display(xb);
}
